/* hidasp.c
 * original: binzume.net
 * modify: senshu , iruka
 * 2008-09-22 : for HIDaspx.
 */

#define DEBUG 		   	0		// for DEBUG

#define DEBUG_PKTDUMP  	0		// HID ReportpPbg_v.
#define DUMP_PRODUCT   	0		// ,i\.

#define CHECK_COUNT		2		// 4: Connect Ping test ̉.

#include <windows.h>
#include <stdio.h>
#include "usbhid.h"
#include "hidasp.h"
#include "avrspx.h"

#include "../firmware/hidcmd.h"


#pragma comment(lib, "setupapi.lib")

//  obdev
#define MY_VID 0x16c0				/* 5824 in dec, stands for VOTI */
#define MY_PID 0x05dc				/* 1500 in dec, obdev's free PID */

#define	MY_Manufacturer	"YCIT"
#define	MY_Product		"HIDaspx"
//	MY_Manufacturer,MY_Product define OƁAVID,PID݂̂̏ƍɂȂ.
//	ǂ炩͂ƁȀƍȗ悤ɂȂ.


// HID API (from w2k DDK)
_HidD_GetAttributes HidD_GetAttributes;
_HidD_GetHidGuid HidD_GetHidGuid;
_HidD_GetPreparsedData HidD_GetPreparsedData;
_HidD_FreePreparsedData HidD_FreePreparsedData;
_HidP_GetCaps HidP_GetCaps;
_HidP_GetValueCaps HidP_GetValueCaps;
_HidD_GetFeature HidD_GetFeature;
_HidD_SetFeature HidD_SetFeature;
_HidD_GetManufacturerString HidD_GetManufacturerString;
_HidD_GetProductString HidD_GetProductString;

HINSTANCE hHID_DLL = NULL;		// hid.dll handle
HANDLE hHID = NULL;				// USB-IO dev handle
HIDP_CAPS Caps;

static	int dev_id      = 0;	// ^[QbgID: 0x55  0x5a e.
static	int have_ledcmd = 0;	// LED̗L.

//----------------------------------------------------------------------------
//--------------------------    Tables    ------------------------------------
//----------------------------------------------------------------------------
//  HID Report ̃pPbg̓TCY TޗpӂĂ.
#define	REPORT_ID1			1	// 8  REPORT_COUNT(6)
#define	REPORT_ID2			2	// 32 REPORT_COUNT(30)
#define	REPORT_ID3			3	// 40 REPORT_COUNT(38)

#define	REPORT_LENGTH1		7	// 8  REPORT_COUNT(6)
#define	REPORT_LENGTH2		31	// 32 REPORT_COUNT(30)
#define	REPORT_LENGTH3		39	// 40 REPORT_COUNT(38)

#define	PAGE_WRITE_LENGTH	32	// Page Writeł32bytePʂ̓]S|.
								// Length57oCgȂlłKv.

//	ő̒ HID ReportID,Length
#define	REPORT_IDMAX		REPORT_ID3
#define	REPORT_LENGTHMAX	REPORT_LENGTH3


#if	DEBUG_PKTDUMP
static	void memdump(char *msg, char *buf, int len);
#endif
/*
 * wrapper for HidD_GetFeature / HidD_SetFeature.
 */
//----------------------------------------------------------------------------
/*
 *	HIDfoCX HID Report 擾.
 *	󂯎obt@͐擪̂PoCgɕKReportIDĂ.
 *
 *	id  Length ̑g̓foCXŒ`ꂽ̂łȂ΂ȂȂ.
 *
 *	߂lHidD_GetFeature̖߂l( 0 = s )
 *
 */
static int hidRead(HANDLE h, char *buf, int Length, int id)
{
	int rc;
	buf[0] = id;
	rc = HidD_GetFeature(h, buf, Length);
#if	DEBUG_PKTDUMP
	memdump("RD", buf, Length);
#endif
	return rc;
}

/*
 *	HIDfoCX HID Report 𑗐M邷.
 *	Mobt@̐擪̂PoCgReportID 鏈
 *	̊֐ōŝŁA擪PoCg\񂵂Ă.
 *
 *	id  Length ̑g̓foCXŒ`ꂽ̂łȂ΂ȂȂ.
 *
 *	߂lHidD_SetFeature̖߂l( 0 = s )
 *
 */
static int hidWrite(HANDLE h, char *buf, int Length, int id)
{
	int rc;
	buf[0] = id;
	rc = HidD_SetFeature(h, buf, Length);
#if	DEBUG_PKTDUMP
	memdump("WR", buf, Length);
#endif
	return rc;
}

/*
 *	hidWrite()gpāAfoCX buf[] f[^ len oCg.
 *	ʂāAReportIDI.
 *
 *	߂lHidD_SetFeature̖߂l( 0 = s )
 *
 */
int	hidWriteBuffer(char *buf, int len)
{
	int report_id = 0;
	int length    = 0;

	if (len <= REPORT_LENGTH1) {
		length= REPORT_LENGTH1;report_id = REPORT_ID1;
	} else if (len <= REPORT_LENGTH2) {
		length= REPORT_LENGTH2;report_id = REPORT_ID2;
	} else if (len <= REPORT_LENGTH3) {
		length= REPORT_LENGTH3;report_id = REPORT_ID3;
	}

	if( report_id == 0) {
		// K؂ȒIłȂ.
		fprintf(stderr, "Error at hidWriteBuffer. len=%d\n",len);
		exit(1);
		return 0;
	}

	return hidWrite(hHID, buf, length, report_id);
}

/*
 *	hidRead()gpāAfoCX buf[] f[^ len oCg擾.
 *	ʂāAReportIDI.
 *
 *	߂lHidD_GetFeature̖߂l( 0 = s )
 *
 */
int	hidReadBuffer(char *buf, int len)
{
	int report_id = 0;
	int length    = 0;

	if (len <= REPORT_LENGTH1) {
		length= REPORT_LENGTH1;report_id = REPORT_ID1;
	} else if (len <= REPORT_LENGTH2) {
		length= REPORT_LENGTH2;report_id = REPORT_ID2;
	} else if (len <= REPORT_LENGTH3) {
		length= REPORT_LENGTH3;report_id = REPORT_ID3;
	}

	if( report_id == 0) {
		// K؂ȒIłȂ.
		fprintf(stderr, "Error at hidWriteBuffer. len=%d\n",len);
		exit(1);
		return 0;
	}

	return hidRead(hHID, buf, length, report_id);
}
/*
 *	hidWrite()gpāAfoCXɂSoCg̏𑗂.
 *	SoCg̓ cmd , arg1 , arg2 , arg 3 ł.
 *  ReportIDID1gp.
 *
 *	߂lHidD_SetFeature̖߂l( 0 = s )
 *
 */
int hidCommand(int cmd,int arg1,int arg2,int arg3)
{
	unsigned char buf[128];

	memset(buf , 0, sizeof(buf) );

	buf[1] = cmd;
	buf[2] = arg1;
	buf[3] = arg2;
	buf[4] = arg3;

	return hidWrite(hHID, buf, REPORT_LENGTH1, REPORT_ID1);
}

//
//	mask@   0 ̏ꍇ́A addr  data0 PoCg.
//	mask@ 0 ̏ꍇ́A addr  data0  mask ̘_ς.
//		AȀꍇ mask bit 0 ɂȂĂ镔ɉe^Ȃ悤ɂ.
//
//	:	PORTB  8bit  data.
//		hidPokeMem( PORTB , data , 0 );
//	:	PORTB  bit2  on
//		hidPokeMem( PORTB , 1<<2 , 1<<2 );
//	:	PORTB  bit2  off
//		hidPokeMem( PORTB ,    0 , 1<<2 );
//
int hidPokeMem(int addr,int data0,int mask)
{
	unsigned char buf[128];
	memset(buf , 0, sizeof(buf) );

	buf[1] = HIDASP_POKE;
	buf[2] = 0;
	buf[3] = addr;
	buf[4] =(addr>>8);
	if( mask ) {
		buf[5] = data0 & mask;
		buf[6] = ~mask;
	}else{
		buf[5] = data0;
		buf[6] = 0;
	}
	return hidWrite(hHID, buf, REPORT_LENGTH1, REPORT_ID1);
}

int hidPeekMem(int addr)
{
	unsigned char buf[128];
	memset(buf , 0, sizeof(buf) );

	buf[1] = HIDASP_PEEK;
	buf[2] = 1;
	buf[3] = addr;
	buf[4] =(addr>>8);

	hidWrite(hHID, buf, REPORT_LENGTH1, REPORT_ID1);
	hidReadBuffer( buf, REPORT_LENGTH1 );
	return buf[1];
}

#define	PORTB			0x38	// PB4=RST PB3=LED
#define	PORTB_WR_MASK	0x1f	// \bit = 0001_1111

/*
 *	LED̐.
#define HIDASP_RST_H_GREEN	0x18	// RST,LED OFF
#define HIDASP_RST_L_BOTH	0x00	// RSTs,LED ON
 */
static void hidSetStatus(int ledstat)
{
	if( have_ledcmd ) {
		hidCommand(HIDASP_SET_STATUS,0,ledstat,0);	// cmd,portd(&0000_0011),portb(&0001_1111),0
	}else{
		hidPokeMem(PORTB,ledstat,PORTB_WR_MASK);
	}
}

////////////////////////////////////////////////////////////////////////
//             hid.dll [h
static int LoadHidDLL()
{
	hHID_DLL = LoadLibrary("hid.dll");
	if (!hHID_DLL) {
#if 1
		fprintf(stderr, "Error at Load 'hid.dll'\n");
#else
		MessageBox(NULL, "Error at Load 'hid.dll'", "ERR", MB_OK);
#endif
		return 0;
	}
	HidD_GetAttributes =
		(_HidD_GetAttributes) GetProcAddress(hHID_DLL,
											 "HidD_GetAttributes");
	if (!HidD_GetAttributes) {
#if 1
		fprintf(stderr, "Error at HidD_GetAttributes\n");
#else
		MessageBox(NULL, "Error at HidD_GetAttributes", "ERR", MB_OK);
#endif
		return 0;
	}
	HidD_GetHidGuid =
		(_HidD_GetHidGuid) GetProcAddress(hHID_DLL, "HidD_GetHidGuid");
	if (!HidD_GetHidGuid) {
#if 1
		fprintf(stderr, "Error at HidD_GetHidGuid\n");
#else
		MessageBox(NULL, "Error at HidD_GetHidGuid", "ERR", MB_OK);
#endif
		return 0;
	}
	HidD_GetPreparsedData =
		(_HidD_GetPreparsedData) GetProcAddress(hHID_DLL,
												"HidD_GetPreparsedData");
	HidD_FreePreparsedData =
		(_HidD_FreePreparsedData) GetProcAddress(hHID_DLL,
												 "HidD_FreePreparsedData");
	HidP_GetCaps =
		(_HidP_GetCaps) GetProcAddress(hHID_DLL, "HidP_GetCaps");
	HidP_GetValueCaps =
		(_HidP_GetValueCaps) GetProcAddress(hHID_DLL, "HidP_GetValueCaps");

//
	HidD_GetFeature =
		(_HidD_GetFeature) GetProcAddress(hHID_DLL, "HidD_GetFeature");
	HidD_SetFeature =
		(_HidD_SetFeature) GetProcAddress(hHID_DLL, "HidD_SetFeature");
	HidD_GetManufacturerString = (_HidD_GetManufacturerString)
		GetProcAddress(hHID_DLL, "HidD_GetManufacturerString");
	HidD_GetProductString = (_HidD_GetProductString)
		GetProcAddress(hHID_DLL, "HidD_GetProductString");

#if	DEBUG
	printf("_HidD_GetFeature= %x\n", (int) HidD_GetFeature);
	printf("_HidD_SetFeature= %x\n", (int) HidD_SetFeature);
#endif
	return 1;
}

////////////////////////////////////////////////////////////////////////
// fBoCX̏擾
static void GetDevCaps()
{
	PHIDP_PREPARSED_DATA PreparsedData;
	HIDP_VALUE_CAPS *VCaps;
	char buf[1024];

	VCaps = (HIDP_VALUE_CAPS *) (&buf);

	HidD_GetPreparsedData(hHID, &PreparsedData);
	HidP_GetCaps(PreparsedData, &Caps);
	HidP_GetValueCaps(HidP_Input, VCaps, &Caps.NumberInputValueCaps,
					  PreparsedData);
	HidD_FreePreparsedData(PreparsedData);

#if DEBUG
	fprintf(stderr, " Caps.OutputReportByteLength = %d\n",
			Caps.OutputReportByteLength);
	fprintf(stderr, " Caps.InputReportByteLength = %d\n",
			Caps.InputReportByteLength);
#endif


#if	REPORT_LENGTH_OVERRIDE
	//REPORT_COUNT݂Ƃ͉LCaps 0 ̂܂܂Ȃ̂ŁA㏑.
	Caps.OutputReportByteLength = REPORT_LENGTH_OVERRIDE;
	Caps.InputReportByteLength = REPORT_LENGTH_OVERRIDE;
#endif
}

//----------------------------------------------------------------------------
/*
 * 	unicode  ASCIIɕϊ.
 */
static char *uni_to_string(char *t, unsigned short *u)
{
	char *buf = t;
	int c;
	// short  char zɓȂ.
	while (1) {
		c = *u++;
		if (c == 0)
			break;
		if (c & 0xff00)
			c = '?';
		*t++ = c;
	}

	*t = 0;
	return buf;
}

//----------------------------------------------------------------------------
/*  Manufacturer & Product name check.
 *  O`FbN : =1  s=0 ǂݎs\=(-1)
 */
static int check_product_string(HANDLE handle)
{
	unsigned short unicode[512];
	char string1[256];
	char string2[256];

	if (!HidD_GetManufacturerString(handle, unicode, sizeof(unicode))) {
		return -1;
	}
	uni_to_string(string1, unicode);

	if (!HidD_GetProductString(handle, unicode, sizeof(unicode))) {
		return -1;
	}
	uni_to_string(string2, unicode);

#if	DUMP_PRODUCT
	fprintf(stderr, "iManufacturer:%s\n", string1);
	fprintf(stderr, "iProduct:%s\n", string2);
#endif

#ifdef	MY_Manufacturer
	if (strcmp(string1, MY_Manufacturer) != 0)
		return 0;
#endif

#ifdef	MY_Product
	if (strcmp(string2, MY_Product) != 0)
		return 0;
#endif

	return 1;					//v.
}

////////////////////////////////////////////////////////////////////////
// HIDfBoCXꗗUSB-IO
static int OpenTheHid()
{
	int f = 0;
	int i = 0;
	ULONG Needed, l;
	GUID HidGuid;
	HDEVINFO DeviceInfoSet;
	HIDD_ATTRIBUTES DeviceAttributes;
	SP_DEVICE_INTERFACE_DATA DevData;
	PSP_INTERFACE_DEVICE_DETAIL_DATA DevDetail;
	//SP_DEVICE_INTERFACE_DETAIL_DATA *MyDeviceInterfaceDetailData;

	DeviceAttributes.Size = sizeof(HIDD_ATTRIBUTES);
	DevData.cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);

	HidD_GetHidGuid(&HidGuid);
#if 1							/* For vista */
	DeviceInfoSet =
		SetupDiGetClassDevs(&HidGuid, NULL, NULL,
							DIGCF_PRESENT | DIGCF_DEVICEINTERFACE);
#else
	DeviceInfoSet =
		SetupDiGetClassDevs(&HidGuid, "", NULL,
							DIGCF_PRESENT | DIGCF_DEVICEINTERFACE);
#endif

	while (SetupDiEnumDeviceInterfaces
		   (DeviceInfoSet, 0, &HidGuid, i++, &DevData)) {
		SetupDiGetDeviceInterfaceDetail(DeviceInfoSet, &DevData, NULL, 0,
										&Needed, 0);
		l = Needed;
		DevDetail =
			(SP_DEVICE_INTERFACE_DETAIL_DATA *) GlobalAlloc(GPTR, l + 4);
		DevDetail->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
		SetupDiGetDeviceInterfaceDetail(DeviceInfoSet, &DevData, DevDetail,
										l, &Needed, 0);

		hHID = CreateFile(DevDetail->DevicePath,
						  GENERIC_READ | GENERIC_WRITE,
						  FILE_SHARE_READ | FILE_SHARE_WRITE,
						  NULL, OPEN_EXISTING,
//                        FILE_FLAG_WRITE_THROUGH | FILE_FLAG_NO_BUFFERING,
						  0, NULL);

		GlobalFree(DevDetail);

		if (hHID == INVALID_HANDLE_VALUE)	// Can't open a device
			continue;
		HidD_GetAttributes(hHID, &DeviceAttributes);

		// HIDaspǂׂ.
		if (DeviceAttributes.VendorID == MY_VID
			&& DeviceAttributes.ProductID == MY_PID
			&& (check_product_string(hHID) == 1)) {
			f = 1;				// ꂽ.
			break;
		} else {
			// 
			CloseHandle(hHID);
			hHID = NULL;
		}
	}
	SetupDiDestroyDeviceInfoList(DeviceInfoSet);
	return f;
}

#if	DEBUG_PKTDUMP
//----------------------------------------------------------------------------
//  [_v.
void memdump(char *msg, char *buf, int len)
{
	int j;
	fprintf(stderr, "%s", msg);
	for (j = 0; j < len; j++) {
		fprintf(stderr, " %02x", buf[j] & 0xff);
		if((j & 0x1f)== 31)
			fprintf(stderr, "\n +");
	}
	fprintf(stderr, "\n");
}
#endif


//----------------------------------------------------------------------------
//  .
//----------------------------------------------------------------------------
int hidasp_init(char *string)
{
	char rd_data[128];
	int i, r;

	LoadHidDLL();
	if (OpenTheHid() == 0) {
#if DEBUG
		fprintf(stderr, "ERROR: fail to OpenTheHid()\n");
#endif
		return 1;
	}

	GetDevCaps();
	Sleep(100);

#if DEBUG
	fprintf(stderr, "HIDASP Connection check!\n");
#endif

	for (i = 0; i < CHECK_COUNT; i++) {
		hidCommand(HIDASP_TEST,(i),0,0);	// Connection test
		r = hidRead(hHID, rd_data ,REPORT_LENGTH1, REPORT_ID1);
#if DEBUG
		fprintf(stderr, "HIDasp Ping(%2d) = %d\n", i, rd_data[1]);
#endif
		if (r == 0) {
			fprintf(stderr, "ERR. fail to Read().\n");
			return 1;
		}
		dev_id = rd_data[1];
		if((dev_id != DEV_ID_FUSION)&&(dev_id != DEV_ID_STD)) {
			fprintf(stderr, "ERR. fail to ping test. (id = %x)\n",dev_id);
			return 1;
		}
		if (rd_data[2] != i) {
			fprintf(stderr, "ERR. fail to ping test. %d != %d\n", rd_data[2] , i);
			return 1;
		}
	}
	hidCommand(HIDASP_SET_STATUS,0,HIDASP_RST_H_GREEN,0);	// RESET HIGH
	r = hidRead(hHID, rd_data ,REPORT_LENGTH1, REPORT_ID1);
	if( rd_data[0] == 0xaa ) {
		have_ledcmd = 1;	// LEDOK.
#if DEBUG
		fprintf(stderr, "LED OK.\n");
#endif
	}else{
#if DEBUG
		fprintf(stderr, "Don't have LED COMMAND.\n");
#endif
	}

#if DEBUG
	fprintf(stderr, "OK.\n");
#endif
	return 0;
}

//----------------------------------------------------------------------------
//  vO.
//----------------------------------------------------------------------------
int hidasp_program_enable(int delay)
{
	unsigned char buf[128];
	unsigned char res[4];
	int i;

	// G[ɂ̓gC悤ɏC by senshu(2008-9-16)
	for (i = 0; i < 3; i++) {
		Sleep(2);
		hidSetStatus(HIDASP_RST_H_GREEN);		// RESET HIGH
		Sleep(10);				// 10 => 100
		hidSetStatus(HIDASP_RST_L_BOTH);		// RESET LOW
		hidCommand(HIDASP_SET_DELAY,delay,0,0);					// SET_DELAY
		Sleep(30);				// 30

		buf[0] = 0xAC;
		buf[1] = 0x53;
		buf[2] = 0x00;
		buf[3] = 0x00;
		hidasp_cmd(buf, res);

		if (res[2] == 0x53) {
#if DEBUG
			fprintf(stderr, "hidasp_program_enable() == OK\n");
#endif
			return 0;
		} else {
#if DEBUG
			fprintf(stderr, "hidasp_program_enable() == NG\n");
#endif
			Sleep(100);
		}
	}
	return 1;
}


#define HIDASP_NOP 			  0	// ISP̃R}hƎv?

//----------------------------------------------------------------------------
//  I.
//----------------------------------------------------------------------------
void hidasp_close()
{
	if (hHID) {
		unsigned char buf[128];

		buf[0] = 0x00;
		buf[1] = HIDASP_NOP;
		buf[2] = 0x00;
		buf[3] = 0x00;
		hidasp_cmd(buf, NULL);	// AVOID BUG!
		hidSetStatus(HIDASP_RST_H_GREEN);		// RESET HIGH
		CloseHandle(hHID);
	}
	if (hHID_DLL) {
		FreeLibrary(hHID_DLL);
	}
	hHID = NULL;
	hHID_DLL = NULL;
}

//----------------------------------------------------------------------------
//  hroR}hs.
//----------------------------------------------------------------------------
int hidasp_cmd(const unsigned char cmd[4], unsigned char res[4])
{
	char buf[128];
	int r;

	memset(buf , 0, sizeof(buf) );
	if (res != NULL) {
		buf[1] = HIDASP_CMD_TX_1;
	} else {
		buf[1] = HIDASP_CMD_TX;
	}
	memcpy(buf + 2, cmd, 4);

	r = hidWrite(hHID, buf, REPORT_LENGTH1 , REPORT_ID1);
#if DEBUG
	fprintf(stderr, "hidasp_cmd %02X, cmd: %02X %02X %02X %02X ", buf[1],
			cmd[0], cmd[1], cmd[2], cmd[3]);
#endif

	if (res != NULL) {
		r = hidRead(hHID, buf, REPORT_LENGTH1 , REPORT_ID1);
		memcpy(res, buf + 1, 4);
#if DEBUG
		fprintf(stderr, " --> res: %02X %02X %02X %02X\n", res[0], res[1],
				res[2], res[3]);
#endif
	}

	return 1;
}


static	void hid_transmit(BYTE cmd1, BYTE cmd2, BYTE cmd3, BYTE cmd4)
{
	unsigned char cmd[4];

	cmd[0] = cmd1;
	cmd[1] = cmd2;
	cmd[2] = cmd3;
	cmd[3] = cmd4;
	hidasp_cmd(cmd, NULL);
}

//----------------------------------------------------------------------------
//  t[WT|[g̃y[WCg.
//----------------------------------------------------------------------------
int hidasp_page_write_fast(long addr, const unsigned char *wd, int pagesize)
{
	int n, l;
	char buf[128];
	int cmd = HIDASP_PAGE_TX_START;

	memset(buf , 0, sizeof(buf) );

	// Load the page data into page buffer
	n = 0;	// n PageBufferւ̏݊_offset.
	while (n < pagesize) {
		l = PAGE_WRITE_LENGTH;		// 32oCgőf[^.
		if (pagesize - n < l) {		// cʂ32oCĝƂ len cʂɒu.
			l = pagesize - n;
		}
		buf[1] = cmd;				// HIDASP_PAGE_TX_* R}h.
		buf[2] = l;					// l       ݃f[^̒.
		memcpy(buf + 3, wd + n, l);	// data[l] ݃f[^.

		if((pagesize - n) == l) {
			buf[1] |= HIDASP_PAGE_TX_FLUSH;		//ŏIpage_writełisp_commandt.
			// ISP R}h.
			buf[3 + l + 0] = C_WR_PAGE;
			buf[3 + l + 1] = (BYTE)(addr >> 9);
			buf[3 + l + 2] = (BYTE)(addr >> 1);
			buf[3 + l + 3] = 0;
		}
		hidWriteBuffer(buf, REPORT_LENGTHMAX);

		n += l;
		cmd = HIDASP_PAGE_TX;		// cmd m[}page_writeɖ߂.
	}


	return 0;
}

//----------------------------------------------------------------------------
//  y[WCg.
//----------------------------------------------------------------------------
int hidasp_page_write(long addr, const unsigned char *wd, int pagesize,int flashsize)
{
	int n, l;
	char buf[128];

	if(	(dev_id == DEV_ID_FUSION) &&
		(flashsize <= (128*1024)) ) {
//		((addr & 0xFF) == 0 	) ) {
		// addres_set , page_write , isp_command Zꂽłs.
		return hidasp_page_write_fast(addr,wd,pagesize);
	}
#if	0
	fprintf(stderr,"dev_id=%x flashsize=%x addr=%x\n",
		dev_id,flashsize,(int)addr
	);
#endif
	// set page
	hidCommand(HIDASP_SET_PAGE,0x40,0,(addr & 0xFF));	// Set Page mode , FlashWrite

	// Load the page data into page buffer
	n = 0;	// n PageBufferւ̏݊_offset.
	while (n < pagesize) {
		l = PAGE_WRITE_LENGTH;	// MAX
		if (pagesize - n < l) {
			l = pagesize - n;
		}
		buf[0] = 0x00;
		buf[1] = HIDASP_PAGE_TX;	// PageBuf
		buf[2] = l;				// Len
		memcpy(buf + 3, wd + n, l);
		hidWriteBuffer(buf,  3 + l);

#if DEBUG
		fprintf(stderr, "  p: %02x %02x %02x %02x\n",
				buf[1] & 0xff, buf[2] & 0xff, buf[3] & 0xff,
				buf[4] & 0xff);
#endif
		n += l;
	}

	/* Load extended address if needed */
	if(flashsize > (128*1024)) {
		hid_transmit(C_LD_ADRX,0,(BYTE)(addr >> 17),0);
	}

	/* Start page programming */
	hid_transmit(C_WR_PAGE,(BYTE)(addr >> 9),(BYTE)(addr >> 1),0);

	return 0;
}

//----------------------------------------------------------------------------
//  y[W[h.
//----------------------------------------------------------------------------
int hidasp_page_read(long addr, unsigned char *wd, int pagesize)
{
	int n, l;
	char buf[128];

	// set page
	if (addr >= 0) {
		hidCommand(HIDASP_SET_PAGE,0x20,0,0);	// Set Page mode , FlashRead
	}

	// Load the page data into page buffer
	n = 0;	// n ͓ǂݍ݊_offset.
	while (n < pagesize) {
		l = REPORT_LENGTHMAX - 1;	// MAX
		if (pagesize - n < l) {
			l = pagesize - n;
		}
		hidCommand(HIDASP_PAGE_RD,l,0,0);	// PageRead , length

		memset(buf + 3, 0, l);
		hidRead(hHID, buf, REPORT_LENGTHMAX, REPORT_IDMAX);
		memcpy(wd + n, buf + 1, l);			// Copy result.

#if 1
		report_update(l);
#else
		if (n % 128 == 0) {
			report_update(128);
		}
#endif

#if DEBUG
		fprintf(stderr, "  p: %02x %02x %02x %02x\n",
				buf[1] & 0xff, buf[2] & 0xff, buf[3] & 0xff,
				buf[4] & 0xff);
#endif
		n += l;
	}

	return 0;
}
//----------------------------------------------------------------------------
